<?php
# ************** LICENCE ****************
/*
	Copyright (c) PORTANEO.

	This file is part of POSH (Portaneo Open Source Homepage) http://sourceforge.net/projects/posh/.

	POSH is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version

	POSH is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Posh.  If not, see <http://www.gnu.org/licenses/>.
*/
# ***************************************
# restricted modules for a user
#
# !! be careful, this file must be saved under uft8 format, and display an e accentuated here : é
#
# ***************************************
/**
*
* \brief Load modules directory branches
*
*   return xml file
*
*  \relatesalso
*   ajax.js
*   $p.app.menu.widget.getExplorer
*
* !! be careful, this file must be saved under uft8 format, and display an e accentuated here : é
*
**/

$folder="";
$not_access=0;
$granted="I";
$pagename="portal/xmlexplorer.php";
//includes
require_once('includes.php');
require_once('../includes/xml.inc.php');

$file=new xmlFile();

$file->header("channel");

$dirId = $_GET['dirid'];

$privateDir = 0;

//get current directory information
$DB->getResults($explorer_getCurrentDirectory, $DB->escape($dirId));
$row = $DB->fetch(0);
echo "<dirname><![CDATA[".$row["name"]." (".$row["q"].")]]></dirname>";
echo "<parent>".$row["parent_id"]."</parent>";
$privateDir = $row["secured"];
$DB->freeResults();

//get subdirectories
$DB->getResults($xmldirectory_getChildrenDirectoryXml, $DB->escape($dirId));

if ($DB->nbResults() > 0) {
	while ($row = $DB->fetch(0)) {
		echo "<dir>";
		echo "<dirid>".$row['id']."</dirid>";
		echo "<dirname><![CDATA[".$row['name']."]]></dirname>";
        echo "<quantity>".$row['quantity']."</quantity>";
        echo "<secured>".$row['secured']."</secured>";
        echo "<secured_quantity>".$row['secured_quantity']."</secured_quantity>";
		echo "</dir>";
	}
}
$DB->freeResults();

if( $privateDir == 1 ) {
	// get secured widgets
	$DB->getResults($xmlexplorer_getPrivateItems,
	                    $DB->escape($dirId),
	                    $DB->escape($_SESSION['user_id']));

	if ($DB->nbResults() > 0) {
		while ($row = $DB->fetch(0)) {
			echo "<item>";
			echo "<id>".$row['id']."</id>";
	        echo "<icon><![CDATA[".$row['icon']."]]></icon>";
	        echo "<secured>1</secured>";
			echo "<name><![CDATA[".$row['name']."]]></name>";
			echo "</item>";
		}
	}

	$DB->freeResults();
} else {
	//cdeseure (#1969) : pour que l'admin puisse disposer des widgets d'un groupe précis dans la gestion des pages
	$user_groupes = array();
	if(isset($_GET['groupe']) && intval($_GET['groupe'])>0 && $_SESSION['type']=="A") $user_groupes[] = intval($_GET['groupe']); //demande par un admin des widgets d'un groupe (voir aussi includes/ajax.js)
	elseif(isset($_SESSION['usergroups']) && is_array($_SESSION['usergroups'])) $user_groupes = array_keys($_SESSION['usergroups']); //cas classique

	//cdeseure (#1976) : on complète la liste des groupes de l'utilisateur en ajoutant tous les groupes parents
	$parent_groupes = array();
	foreach($user_groupes as $id_groupe)
		{
		while($id_groupe>0)
			{
			$DB->getResults("SELECT `parent_id` FROM `users_group` WHERE `id`=%u LIMIT 1;",$DB->escape($id_groupe));
			if($DB->nbResults()>0)
				{
				$row = $DB->fetch(0);
				$id_groupe = intval($row["parent_id"]); //vaut 0 si inexistant
				if($id_groupe>0 && !in_array($id_groupe,$parent_groupes)) $parent_groupes[] = $id_groupe;
				}
			else $id_groupe = 0;
			$DB->freeResults();
			}
		}
	$user_groupes = array_unique(array_merge($user_groupes,$parent_groupes));

	// get public widgets
	$DB->getResults($xmlexplorer_getPublicItems,$DB->escape($dirId));
	if ($DB->nbResults() > 0 ) {
		while ($row = $DB->fetch(0)) {
            $group_access = $row['group_access'];
            //public widgets
            if ($group_access == 0) {
                echo "<item>";
                echo "<id>".$row['id']."</id>";
                echo "<icon><![CDATA[".$row['icon']."]]></icon>";
                echo "<secured>0</secured>";
                echo "<name><![CDATA[".$row['name']."]]></name>";
                echo "<group_access>0</group_access>";
                echo "</item>";
            }
            else {  
                $groups = explode(",", $group_access);

                //cdeseure (#1978) : si un même widget est autorisé pour plusieurs groupes d'un utilisateur, il ne doit s'afficher qu'une fois
                $autorisation = false;
                for($i=0;$i<count($groups);$i++)
                    {
                    if(in_array($groups[$i],$user_groupes)) { $autorisation = true; break; }
                    }
                if($autorisation)
                    {
                    echo "<item>";
                    echo "<id >".$row['id']."</id>";
                    echo "<icon><![CDATA[".$row['icon']."]]></icon>";
                    echo "<secured>0</secured>";
                    echo "<name><![CDATA[".$row['name']."]]></name>";
                    echo "<group_access><![CDATA[".$group_access."]]></group_access>";
                    echo "</item>";
                    }           
            }
		}
	}
	$DB->freeResults();
}

$file->footer();

$DB->close();
?>
